﻿<Graph ClassName="BackloadEntry" Source="#CDATA" IsNew="True" FileType="NewGraph">
    <CDATA name="Source"><![CDATA[using System;
using PX.Data;
using DispatchSetup;
using System.Collections.Generic;
using System.Collections;
using PX.Objects.IN;
using PX.Objects.PO;
using PX.Objects.CR;
using System.Linq;
using PX.Objects.AP;
using PX.Objects.SO;
using PX.Objects.CS;
using PX.Objects.AR;
using PX.Objects.EP;
using DispatchExtension;

namespace Dispatch
{
    
  public class BackloadEntry : PXGraph<BackloadEntry>
  {
        public PXSetup<DispatchNumberingSetup> Setup;
        public PXSave<Backload> Save;
        public PXCancel<Backload> Cancel;
        public PXSelect<Backload> BackloadHead;
        public PXSelect<
            BackloadLine,
            Where<BackloadLine.backloadNbr,Equal<Current<Backload.backloadNbr>>>> 
            BackloadLine;
        public PXSelect<BackloadSplit,
            Where<BackloadSplit.backloadNbr, Equal<Current<BackloadLine.backloadNbr>>,And<BackloadSplit.backloadLineNbr,Equal<Current<BackloadLine.backloadLineNbr>>>>> backloadSplits;


    public BackloadEntry()
    {
            Reports.AddMenuAction(Sample);
            MyActions.AddMenuAction(Release);
            MyActions.AddMenuAction(SplitBackloadLine);
    }

        #region Actions
        #region Reports
        public PXAction<Backload> Reports;
        [PXButton(SpecialType = PXSpecialButtonType.ActionsFolder, MenuAutoOpen = true)]
        [PXUIField(DisplayName = "Reports", MapEnableRights = PXCacheRights.Select, MapViewRights = PXCacheRights.Select)]
        public void reports()
        {

        }
        #endregion
        #region Action
        public PXAction<Backload> MyActions;
        [PXButton(SpecialType = PXSpecialButtonType.ActionsFolder, MenuAutoOpen = true)]
        [PXUIField(DisplayName = "Actions", MapEnableRights = PXCacheRights.Select, MapViewRights = PXCacheRights.Select)]
        public void myActions()
        {

        }
        #endregion
        #region Report
        public PXAction<Backload> Sample;
        [PXButton(CommitChanges = true)]
        [PXUIField(DisplayName = "Sample Report")]
        public IEnumerable sample(PXAdapter adapter)
        {
            return adapter.Get();
        }
        #endregion
        #region Release
        public PXAction<Backload> Release;
        [PXButton(CommitChanges = true)]
        [PXUIField(DisplayName = "Release")]
        public IEnumerable release(PXAdapter adapter)
        {
            
            var soGraph = PXGraph.CreateInstance<SOOrderEntry>();
            var currentSetup = Setup.Current;
            List<BackloadLine> withReturn = new List<BackloadLine>();
            List<BackloadLine> withoutReturn = new List<BackloadLine>();
            var shipmentEntry = PXGraph.CreateInstance<SOShipmentEntry>();
            var cur = BackloadHead.Current;
            if (cur.Tstamp == null) { throw new PXException("Save the document first before releasing."); }

            foreach (BackloadLine lines in BackloadLine.Select())
            {
                if (lines.Qty > 0)
                {
                    BackloadLine.Current = lines;
                    decimal? total = BackloadLine.Select().RowCast<BackloadLine>().Where(r => r.BackloadLineNbr == lines.BackloadLineNbr).Sum(f => f.Qty);
                    decimal? totalBackloadSplit = backloadSplits.Select().RowCast<BackloadSplit>().Where(d => d.BackloadLineNbr == lines.BackloadLineNbr).Sum(f => f.Qty);
                    PXTrace.WriteInformation("InventoryID: " + lines.InventoryID.ToString() + " Qty line: " + total.ToString() + " BackloadSplit Qty: " + totalBackloadSplit.ToString());
                    BackloadType blType = PXSelect<
                        BackloadType, 
                        Where<BackloadType.backloadTypeCD, Equal<Required<BackloadType.backloadTypeCD>>>>
                        .Select(this, lines.BackloadType);
                    INLotSerClass lot = PXSelectJoin<INLotSerClass,
                     LeftJoin<InventoryItem, On<InventoryItem.lotSerClassID, Equal<INLotSerClass.lotSerClassID>>>,
                     Where<InventoryItem.inventoryID, Equal<Required<InventoryItem.inventoryID>>>>.Select(this, BackloadLine.Current.InventoryID);
                    InventoryItem item = PXSelect<InventoryItem, Where<InventoryItem.inventoryID,Equal<Required<InventoryItem.inventoryID>>>>.Select(this,lines.InventoryID);
                    if (lot.LotSerTrack == INLotSerTrack.LotNumbered || lot.LotSerTrack == INLotSerTrack.SerialNumbered) {
                    if(totalBackloadSplit <= 0)
                        {
                            BackloadLine.Cache.RaiseExceptionHandling<BackloadLine.backloadNbr>(lines,lines.BackloadNbr,new PXSetPropertyException("Item " + item.Descr + " is required for serial nbr.",PXErrorLevel.RowError));
                            throw new PXException("Item " + item.Descr + " is required for serial nbr.");
                        }
                    if(totalBackloadSplit != total)
                        {
                            BackloadLine.Cache.RaiseExceptionHandling<BackloadLine.backloadNbr>(lines, lines.BackloadNbr, new PXSetPropertyException("Item " + item.Descr + " allocations qty is not equal to Backload qty", PXErrorLevel.RowError));
                            throw new PXException("Item " + item.Descr + " allocations qty is not equal to Backload qty");
                        }
                    }
                    if(blType.Damage == true)
                    {
                        if (Setup.Current.AutoRTV == true)
                        {
                            if (lines.VendorCD == null || lines.VendorID == null)
                            {
                                BackloadLine.Cache.RaiseExceptionHandling<BackloadLine.vendorCD>(lines, lines.VendorCD, new PXSetPropertyException("Vendor is required for creating RTV Document", PXErrorLevel.Error));
                                throw new PXException("Vendor is empty");
                            }
                        }
                    }
                    if (lines.BackloadType == blType.BackloadTypeCD && blType.BackloadReturn == true)
                    {
                        if (!withReturn.Contains(lines))
                        {
                            withReturn.Add(lines);
                        }
                    }
                    if(blType.Issue == true || blType.WithBuffer == true || blType.OneStepStaging == true || blType.OneStepDefaultWarehouseLocation == true || blType.ReturnToDmgWarehouse == true)
                    {
                        if (!withoutReturn.Contains(lines))
                        {
                            withoutReturn.Add(lines);
                        }
                    }
                }
            }
            PXLongOperation.StartOperation(this, delegate
             {
                 using (PXTransactionScope trn = new PXTransactionScope())
                 {

                     if (withReturn.Count() > 0)
                    {
                         CreateCM(this, withReturn);
                         TransferGoodsDamage(withReturn, this);
                         if (Setup.Current.AutoRTV == true)
                         {
                             AutoCreateRTV(withReturn, this);
                         }
                    }
                    if (withoutReturn.Count() > 0)
                    {
                         CreateTransferIssue(this, withoutReturn);
                         if (Setup.Current.AutoRTV == true)
                         {
                             AutoCreateRTV(withoutReturn, this);
                         }
                    }
                    BackloadHead.Cache.SetValueExt<Backload.backloadStatus>(BackloadHead.Current, BackloadStatus.Completed);
                    BackloadHead.Update(BackloadHead.Current);
                    Actions.PressSave();
                    foreach (BackloadLine line in BackloadLine.Select())
                    {
                        SOShipLine shipLine = PXSelect<SOShipLine, Where<SOShipLine.shipmentNbr, Equal<Required<SOShipLine.shipmentNbr>>
                            , And<SOShipLine.shipmentType, Equal<Required<SOShipLine.shipmentType>>, And<SOShipLine.lineNbr, Equal<Required<SOShipLine.lineNbr>>>>>>.Select(shipmentEntry, line.ShipmentNbr, line.ShipmentType, line.ShipmentLineNbr);
                         var shipLineExt = PXCache<SOShipLine>.GetExtension<SOShipLineExt>(shipLine);
                        decimal? total = BackloadLine.Select().RowCast<BackloadLine>().Where(r => r.BackloadLineNbr == line.BackloadLineNbr).Sum(f => f.Qty);
                        shipmentEntry.Transactions.Cache.SetValue<SOShipLineExt.usrBLQty>(shipLine, shipLineExt.UsrBLQty + total);
                        shipmentEntry.Transactions.Update(shipLine);
                    }
                    shipmentEntry.Persist();
                 trn.Complete();
             }

             });
            return adapter.Get();
        }
        #endregion
        #region Split
        public PXAction<Backload> SplitBackloadLine;
        [PXButton(CommitChanges = true)]
        [PXUIField(DisplayName = "Split Line")]
        public void splitBackloadLine()
        {
            var doc = BackloadHead.Current;
            foreach(BackloadLine line in BackloadLine.Select().RowCast<BackloadLine>().Where(d => d.ShipmentNbr == BackloadLine.Current.ShipmentNbr
            && d.ShipmentType == BackloadLine.Current.ShipmentType && d.ShipmentLineNbr == BackloadLine.Current.ShipmentLineNbr))
            {
                decimal? total = BackloadLine.Select().RowCast<BackloadLine>().Where(r => r.BackloadLineNbr == line.BackloadLineNbr).Sum(f => f.Qty);
                SOShipLine shipLine = PXSelectJoin<
                    SOShipLine,
                    LeftJoin<BackloadLine,
                        On<BackloadLine.shipmentType,Equal<SOShipLine.shipmentType>,
                        And<BackloadLine.shipmentNbr,Equal<SOShipLine.shipmentNbr>,
                        And<BackloadLine.shipmentLineNbr,Equal<SOShipLine.lineNbr>>>>>,
                    Where<SOShipLine.shipmentType,Equal<Required<SOShipLine.shipmentType>>,
                        And<SOShipLine.shipmentNbr,Equal<Required<SOShipLine.shipmentNbr>>,
                        And<SOShipLine.lineNbr,Equal<Required<SOShipLine.lineNbr>>,
                        And<BackloadLine.recordID, Equal<Required<BackloadLine.recordID>>>>>>>
                    .Select(this, line.ShipmentType,line.ShipmentNbr,line.ShipmentLineNbr,line.RecordID);
                var shipLineExt = PXCache<SOShipLine>.GetExtension<SOShipLineExt>(shipLine);
                if (shipLine == null) return;
                if(line.Qty == 0m)
                {
                    throw new PXException("Please input Qty first before splitting the line.");
                }
                if(doc.IsCM == true)
                {
                    if(total >= shipLine.ShippedQty)
                    {
                        throw new PXException("Backload Qty must not be greater than shipped qty");
                    }
                }
                if (doc.IsCM != true)
                {
                    if (total >= shipLineExt.UsrAvailBackloadQty)
                    {
                        throw new PXException("Backload Qty must not be greater than Shipments available backload qty");
                    }
                }
                BackloadLine newObj = PXCache<BackloadLine>.CreateCopy(line);
                newObj.RecordID = null;
                newObj.BackloadLineNbr = null;
                newObj.Qty = 0;
                BackloadLine.Insert(newObj);
            }
        }
        #endregion
        #region Allocations

        public PXAction<Backload> Allocations;
        [PXButton()]
        [PXUIField(DisplayName = "Allocations")]
        public void allocations()
        {
            INLotSerClass lot = PXSelectJoin<INLotSerClass,
                 LeftJoin<InventoryItem, On<InventoryItem.lotSerClassID, Equal<INLotSerClass.lotSerClassID>>>,
                 Where<InventoryItem.inventoryID, Equal<Required<InventoryItem.inventoryID>>>>.Select(this, BackloadLine.Current.InventoryID);
            if(lot.LotSerTrack == INLotSerTrack.NotNumbered) { throw new PXException("Item is not serialized"); }
            if (BackloadLine.Current.Qty == 0m) { throw new PXException("Backload Qty must not equal to 0"); }
            backloadSplits.AskExt();
        }

        #endregion
        #endregion

        #region Events

        public void Backload_RowSelected(PXCache sender, PXRowSelectedEventArgs e)
        {
            var row = e.Row as Backload;
            if (row == null) return;
            
            PXUIFieldAttribute.SetEnabled<Backload.backloadStatus>(sender, row, false);
            PXUIFieldAttribute.SetEnabled<Backload.hold>(sender, row, row.BackloadStatus != BackloadStatus.Completed);
            PXUIFieldAttribute.SetEnabled<Backload.customerID>(sender, row, false);
            PXUIFieldAttribute.SetEnabled<Backload.customerIDLocation>(sender, row, false);
            PXUIFieldAttribute.SetEnabled<Backload.backloadDate>(sender, row, row.BackloadStatus != BackloadStatus.Completed);
            Release.SetEnabled(row.BackloadStatus == BackloadStatus.Open);
            SplitBackloadLine.SetEnabled(row.BackloadStatus != BackloadStatus.Completed);
            PXUIFieldAttribute.SetVisible<BackloadLine.creditMemoRefNo>(sender, null, row.IsCM == true);
        }

        public void Backload_RowPersisted(PXCache sender, PXRowPersistedEventArgs e)
        {
            var row = e.Row as Backload;
            if (row == null) return;
            string shipmentNbr = BackloadLine.Current.ShipmentNbr;

            if (row.Tstamp == null && row.IsCM == true)
            {
                var graph = PXGraph.CreateInstance<SOShipmentEntry>();
                graph.Document.Current = graph.Document.Search<SOShipment.shipmentNbr>(shipmentNbr, SOShipmentType.Issue);
                graph.Document.Update(graph.Document.Current);

                foreach (SOShipLine line in graph.Transactions.Select())
                {
                    var lineExt = PXCache<SOShipLine>.GetExtension<SOShipLineExt>(line);
                    graph.Transactions.Cache.SetValue<SOShipLineExt.usrBLCMNbr>(line, row.BackloadNbr);
                    graph.Transactions.Update(line);
                }
                graph.Persist();
            }
        }

        public virtual void Backload_Hold_FieldUpdated(PXCache sender, PXFieldUpdatedEventArgs e)
        {
            var row = e.Row as Backload;
            if (row == null) return;

            if(row.Hold == true)
            {
                sender.SetValueExt<Backload.backloadStatus>(row, BackloadStatus.Hold);
            }
            else
            {
                sender.SetValueExt<Backload.backloadStatus>(row, BackloadStatus.Open);
            }
            sender.SetValueExt<Backload.siteID>(row, BackloadLine.Current.SiteID);

        }

        public virtual void BackloadLine_Qty_FieldUpdated(PXCache sender, PXFieldUpdatedEventArgs e)
        {
            var row = e.Row as BackloadLine;
            if (row == null) return;
            INLotSerClass lotClass = PXSelectJoin<INLotSerClass,
                        LeftJoin<InventoryItem, On<InventoryItem.lotSerClassID, Equal<INLotSerClass.lotSerClassID>>>,
                        Where<InventoryItem.inventoryID, Equal<Required<InventoryItem.inventoryID>>>>.Select(this, row.InventoryID);
            if (lotClass.LotSerTrack != INLotSerTrack.NotNumbered)
            {
                if (backloadSplits.Select().Count == 0)
                {
                    if (BackloadLine.Current.Qty > 0m)
                    {
                        BackloadSplit splt = (BackloadSplit)backloadSplits.Cache.CreateInstance();
                        splt.BaseQty = row.Qty;
                        backloadSplits.Insert(splt);
                    }
                }
            }
            
        }

        public virtual void BackloadLine_RowSelected(PXCache sender, PXRowSelectedEventArgs e)
        {
            var row = e.Row as BackloadLine;
            if (row == null) return;
            PXUIFieldAttribute.SetEnabled(sender, row, false);

            PXUIFieldAttribute.SetEnabled<BackloadLine.qty>(sender, row, BackloadHead.Current.BackloadStatus != BackloadStatus.Completed && row.Tstamp != null);
            PXUIFieldAttribute.SetEnabled<BackloadLine.backloadType>(sender, row, BackloadHead.Current.BackloadStatus != BackloadStatus.Completed);
            if (row.BackloadType != null)
            {
                foreach (BackloadType item in PXSelect<BackloadType, Where<BackloadType.backloadTypeCD, Equal<Required<BackloadType.backloadTypeCD>>>>.Select(this, row.BackloadType))
                {
                    PXUIFieldAttribute.SetEnabled<BackloadLine.vendorCD>(sender, row, item.Damage == true && BackloadHead.Current.BackloadStatus != BackloadStatus.Completed);
                }
            }
            PXUIFieldAttribute.SetVisible<BackloadLine.creditMemoRefNo>(sender, null, BackloadHead.Current.IsCM == true);
            PXUIFieldAttribute.SetVisible<BackloadLine.rtvRefNbr>(sender, null, Setup.Current.AutoRTV == true);
            PXUIFieldAttribute.SetVisible<BackloadLine.issueRefNbr>(sender, null, Setup.Current.ChargeToEmployee == true);
            PXUIFieldAttribute.SetVisible<BackloadLine.vendorCD>(sender, null, Setup.Current.AutoRTV == true);

        }

        public virtual void BackloadLine_VendorCD_FieldUpdated(PXCache sender, PXFieldUpdatedEventArgs e)
        {
            var row = e.Row as BackloadLine;
            if (row == null) return;
            BAccount accnt = PXSelectJoin<BAccount, InnerJoin<POVendorInventory,On<POVendorInventory.vendorID, Equal<BAccount.bAccountID>>>,Where<BAccount.acctCD,Equal<Required<BAccount.acctCD>>>>.Select(this,row.VendorCD);
            if (accnt != null)
            {
                row.VendorID = accnt.BAccountID;
            }
            if(row.VendorCD == null)
            {
                row.VendorID = null;
            }
        }

        public virtual void BackloadLine_BackloadType_FieldUpdated(PXCache sender, PXFieldUpdatedEventArgs e)
        {
            var row = e.Row as BackloadLine;
            if (row == null) return;
            BackloadType blType = PXSelect<
                BackloadType, 
                Where<BackloadType.backloadTypeCD, Equal<Required<BackloadType.backloadTypeCD>>>>
                .Select(this, row.BackloadType);
            SOShipLine shipmentSelect = PXSelect<
                SOShipLine, 
                Where<SOShipLine.shipmentNbr, Equal<Required<SOShipLine.shipmentNbr>>, 
                    And<SOShipLine.shipmentType, Equal<Required<SOShipLine.shipmentType>>,
                    And<SOShipLine.lineNbr, Equal<Required<SOShipLine.lineNbr>>>>>>
                .Select(this, row.ShipmentNbr, row.ShipmentType, row.ShipmentLineNbr);
            if (shipmentSelect == null) return;
            SOShipLineExt shipmentSelectExt = PXCache<SOShipLine>.GetExtension<SOShipLineExt>(shipmentSelect);
            if (row.BackloadType == blType.BackloadTypeCD && blType.WithBuffer == true)
            {
                if (shipmentSelectExt.UsrBufferQty == 0)
                {
                    throw new PXException("There is no Buffer Qty in Shipment");
                }
            }
            BackloadSplit mySplt = PXSelect<BackloadSplit, Where<BackloadSplit.backloadNbr, Equal<Required<BackloadSplit.backloadNbr>>, And<BackloadSplit.backloadRecordID, Equal<Required<BackloadSplit.backloadRecordID>>>>>.Select(this, row.BackloadNbr, row.RecordID);
            if (mySplt != null)
            {
                backloadSplits.Cache.SetValue<BackloadSplit.backloadType>(mySplt, row.BackloadType);
                backloadSplits.Update(mySplt);
            }
        }
        public virtual void BackloadLine_RowPersisting(PXCache sender, PXRowPersistingEventArgs e)
        {
            var row = e.Row as BackloadLine;
            if (row == null) return;
            BackloadType type = PXSelect<BackloadType, Where<BackloadType.backloadTypeCD, Equal<Required<BackloadType.backloadTypeCD>>>>.Select(this, row.BackloadType);
            SOShipLine shipLine = PXSelect<
               SOShipLine,
               Where<SOShipLine.shipmentType, Equal<Required<SOShipLine.shipmentType>>,
                   And<SOShipLine.shipmentNbr, Equal<Required<SOShipLine.shipmentNbr>>,
                   And<SOShipLine.lineNbr, Equal<Required<SOShipLine.lineNbr>>>>>>
               .Select(this, row.ShipmentType, row.ShipmentNbr, row.ShipmentLineNbr);
            if (row.BackloadType == null) {
                sender.RaiseExceptionHandling<BackloadLine.backloadType>(row, null, new PXSetPropertyException("Backload Type is empty.", PXErrorLevel.Error));
            }
            var shipLineExt = PXCache<SOShipLine>.GetExtension<SOShipLineExt>(shipLine);
            decimal? total = BackloadLine.Select().RowCast<BackloadLine>().Where(r => r.ShipmentLineNbr == row.ShipmentLineNbr).Sum(f => f.Qty);
            if (type.BackloadReturn == true)
            {
                if (total > shipLine.ShippedQty)
                {
                    sender.RaiseExceptionHandling<BackloadLine.qty>(row, row.Qty, new PXSetPropertyException("Qty is greater than shipped qty", PXErrorLevel.Error));
                }
            }
            else
            {
                if(total > shipLineExt.UsrAvailBackloadQty)
                {
                    sender.RaiseExceptionHandling<BackloadLine.qty>(row, row.Qty, new PXSetPropertyException("Qty is greather than available backload qty"));
                }
            }

        }

        public virtual void BackloadSplit_RowInserting(PXCache sender, PXRowInsertingEventArgs e)
        {
            var row = e.Row as BackloadSplit;
            if (row == null) ;
            sender.SetDefaultExt<BackloadSplit.backloadType>(row);
        }

        public virtual void BackloadSplit_RowPersisting(PXCache sender, PXRowPersistingEventArgs e)
        {
            var row = e.Row as BackloadSplit;
            if (row == null) return;
            var current = BackloadHead.Current;
            
            if (current.IsCM == true)
            {
                if (row.LotSerialNbr == null)
                {
                    foreach (BackloadLine line in BackloadLine.Select().RowCast<BackloadLine>().Where(d=> d.BackloadLineNbr == row.BackloadLineNbr && d.InventoryID == row.InventoryID))
                    {
                        BackloadLine.Current = line;
                        BackloadLine.Cache.RaiseExceptionHandling<BackloadLine.qty>(line, line.Qty, new PXSetPropertyException("Serial Nbr is Required", PXErrorLevel.RowWarning));
                        throw new PXException("Lot Serial Nbr is Required");
                    }
                }
            }
            if (current.IsCM != true)
            {
                if (row.NonCmLotSerialNbr == null)
                {
                    foreach (BackloadLine line in BackloadLine.Select().RowCast<BackloadLine>().Where(d => d.BackloadLineNbr == row.BackloadLineNbr && d.InventoryID == row.InventoryID))
                    {
                        BackloadLine.Current = line;
                        BackloadLine.Cache.RaiseExceptionHandling<BackloadLine.qty>(BackloadLine.Current, BackloadLine.Current.Qty, new PXSetPropertyException("Serial Nbr is Required", PXErrorLevel.RowWarning));
                        throw new PXException("Lot Serial Nbr is Required");
                    }
                }
            }
            
        }

        public virtual void BackloadSplit_LotSerialNbr_FieldUpdated(PXCache sender, PXFieldUpdatedEventArgs e)
        {
            var row = e.Row as BackloadSplit;
            if (row == null) return;
            INLotSerClass lot = PXSelectJoin<INLotSerClass,
                     LeftJoin<InventoryItem, On<InventoryItem.lotSerClassID, Equal<INLotSerClass.lotSerClassID>>>,
                     Where<InventoryItem.inventoryID, Equal<Required<InventoryItem.inventoryID>>>>.Select(this, row.InventoryID);
            if(lot.LotSerTrack == INLotSerTrack.SerialNumbered)
            {
                sender.SetValue<BackloadSplit.qty>(row, 1m);
                foreach (BackloadSplit splt in backloadSplits.Select())
                {
                    if(splt.LotSerialNbr == row.LotSerialNbr && splt.LineNbr != row.LineNbr)
                    {
                        sender.RaiseExceptionHandling<BackloadSplit.lotSerialNbr>(row, null,new PXSetPropertyException("Serial Nbr " +row.LotSerialNbr+ " is already allocated",PXErrorLevel.Warning));
                        sender.SetValue<BackloadSplit.lotSerialNbr>(row, null);
                        sender.SetValue<BackloadSplit.qty>(row, 0m);
                    }
                }
            }

        }

        public virtual void BackloadSplit_NonCmLotSerialNbr_FieldUpdated(PXCache sender, PXFieldUpdatedEventArgs e)
        {
            var row = e.Row as BackloadSplit;
            if (row == null) return;
            INLotSerClass lot = PXSelectJoin<INLotSerClass,
                     LeftJoin<InventoryItem, On<InventoryItem.lotSerClassID, Equal<INLotSerClass.lotSerClassID>>>,
                     Where<InventoryItem.inventoryID, Equal<Required<InventoryItem.inventoryID>>>>.Select(this, row.InventoryID);
            if (lot.LotSerTrack == INLotSerTrack.SerialNumbered)
            {
                sender.SetValue<BackloadSplit.qty>(row, 1m);
                foreach (BackloadSplit splt in backloadSplits.Select())
                {
                    if (splt.NonCmLotSerialNbr == row.NonCmLotSerialNbr && splt.LineNbr != row.LineNbr)
                    {
                        sender.RaiseExceptionHandling<BackloadSplit.nonCmLotSerialNbr>(row, null, new PXSetPropertyException("Serial Nbr " + row.NonCmLotSerialNbr + " is already allocated", PXErrorLevel.Warning));
                        sender.SetValue<BackloadSplit.nonCmLotSerialNbr>(row, null);
                        sender.SetValue<BackloadSplit.qty>(row, 0m);
                    }
                }
            }
        }

        public virtual void BackloadSplit_RowSelected(PXCache sender, PXRowSelectedEventArgs e)
        {
            var row = e.Row as BackloadSplit;
            var current = BackloadHead.Current;
            PXUIFieldAttribute.SetVisible<BackloadSplit.nonCmLotSerialNbr>(sender, null, current.IsCM != true);
            PXUIFieldAttribute.SetVisible<BackloadSplit.lotSerialNbr>(sender, null, current.IsCM == true);
        }
        public virtual void BackloadSplit_BackloadType_FieldDefaulting(PXCache sender, PXFieldDefaultingEventArgs e)
        {
            var row = e.Row as BackloadSplit;
            if (row == null) return;
            BackloadLine splts = PXSelect<BackloadLine,Where<BackloadLine.backloadNbr,Equal<Required<BackloadLine.backloadNbr>>,
                And<BackloadLine.backloadLineNbr, Equal<Required<BackloadLine.backloadLineNbr>>>>>.Select(this,row.BackloadNbr,row.BackloadLineNbr);
            if(splts != null)
            {
                e.NewValue = splts.BackloadType;
            }
        }
        #endregion
        #region Method

        public static void CreateCM(BackloadEntry graph, List<BackloadLine> lst)
        {
            
            var soGraph = PXGraph.CreateInstance<SOOrderEntry>();
            var shipGraph = PXGraph.CreateInstance<SOShipmentEntry>();
           
            
            SOOrder order = (SOOrder)soGraph.Document.Cache.CreateInstance();
            order.OrderType = graph.Setup.Current.BackloadReturnType;
            order = soGraph.Document.Insert(order);
            order = PXCache<SOOrder>.CreateCopy(soGraph.Document.Search<SOOrder.orderNbr>(order.OrderNbr));

            order.CustomerID = graph.BackloadHead.Current.CustomerID;
            order.CustomerLocationID = graph.BackloadHead.Current.CustomerIDLocation;
            order.Hold = false;
            order.DefaultSiteID = graph.BackloadLine.Current.SiteID;
            order = PXCache<SOOrder>.CreateCopy(soGraph.Document.Update(order));
            var lineGrp = lst.GroupBy(s => s.ShipmentLineNbr);
            foreach (var grp in lineGrp)
            {
                List<string> lotNbr = new List<string>();
                List<string> serLotNbr = new List<string>();
                List<string> nonSerial = new List<string>();
                var lineNbr = grp.Key;
                foreach (BackloadLine line in grp)
                {
                    graph.BackloadLine.Current = line;
                    decimal? total = graph.BackloadLine.Select().RowCast<BackloadLine>().Where(r => r.ShipmentLineNbr == line.ShipmentLineNbr).Sum(f => f.Qty);
                    var lotSerialGroupBy = PXSelect<BackloadSplit, Where<BackloadSplit.backloadNbr,Equal<Required<BackloadSplit.backloadNbr>>,
                        And<BackloadSplit.backloadLineNbr, Equal<Required<BackloadSplit.backloadLineNbr>>>>>.Select(graph,line.BackloadNbr,line.BackloadLineNbr).RowCast<BackloadSplit>().GroupBy(i=> i.LotSerialNbr);
                    
                    INLotSerClass lotClass = PXSelectJoin<INLotSerClass,
                        LeftJoin<InventoryItem, On<InventoryItem.lotSerClassID, Equal<INLotSerClass.lotSerClassID>>>,
                        Where<InventoryItem.inventoryID, Equal<Required<InventoryItem.inventoryID>>>>.Select(graph, line.InventoryID);
                    AddInvoiceFilter addInv = soGraph.addinvoicefilter.Select();
                    addInv.DocType = ARDocType.Invoice;
                    addInv.RefNbr = line.InvoiceNbr;
                    soGraph.addinvoicefilter.Update(addInv);
                    BackloadSplit splt = PXSelect<BackloadSplit, Where<BackloadSplit.backloadNbr, Equal<Required<BackloadSplit.backloadNbr>>,
                        And<BackloadSplit.shipmentLineNbr,Equal<Required<BackloadSplit.shipmentLineNbr>>>>>.Select(soGraph,line.BackloadNbr,line.ShipmentLineNbr);
                   
                    ARTran arTran = PXSelect<ARTran, Where<ARTran.sOShipmentNbr, Equal<Required<ARTran.sOShipmentNbr>>,
                        And<ARTran.sOShipmentType, Equal<Required<ARTran.sOShipmentType>>,
                        And<ARTran.sOShipmentLineNbr, Equal<Required<ARTran.sOShipmentLineNbr>>>>>>.Select(graph, line.ShipmentNbr, line.ShipmentType, lineNbr);
                    foreach (InvoiceSplits item in soGraph.invoicesplits.Select().RowCast<InvoiceSplits>().Where(d => d.RefNbrARTran == arTran.RefNbr && d.TranTypeARTran == arTran.TranType && d.LineNbrARTran == arTran.LineNbr))
                    {
                        if (splt != null)
                        {
                            if (lotClass.LotSerTrack != INLotSerTrack.LotNumbered)
                            {
                                foreach (BackloadSplit bSplits in PXSelect<BackloadSplit, Where<BackloadSplit.backloadNbr, Equal<Required<BackloadSplit.backloadNbr>>, And<BackloadSplit.shipmentLineNbr, Equal<Required<BackloadSplit.shipmentLineNbr>>>>>.Select(graph, line.BackloadNbr, line.ShipmentLineNbr))
                                {
                                    if (bSplits != null)
                                    {
                                        if (bSplits.LotSerialNbr == item.LotSerialNbr)
                                        {
                                            if (!serLotNbr.Contains(bSplits.LotSerialNbr))
                                            {
                                                serLotNbr.Add(bSplits.LotSerialNbr);
                                                item.Selected = true;
                                                soGraph.invoicesplits.Update(item);
                                            }
                                        }
                                    }
                                }
                            }
                            if (lotClass.LotSerTrack == INLotSerTrack.LotNumbered)
                            {
                                foreach (var items in lotSerialGroupBy)
                                {
                                    var keyLot = items.Key;
                                    foreach (BackloadSplit spltItem in items)
                                    {
                                        if (!lotNbr.Contains(spltItem.LotSerialNbr))
                                        {
                                            if (item.LotSerialNbr == keyLot)
                                            {
                                                lotNbr.Add(spltItem.LotSerialNbr);
                                                item.Selected = true;
                                                soGraph.invoicesplits.Update(item);
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        else
                        {
                            if (!nonSerial.Contains(item.LotSerialNbr))
                            {
                                nonSerial.Add(item.LotSerialNbr);
                                item.Selected = true;
                            }
                        }
                        soGraph.invoicesplits.Update(item);
                    }
                    soGraph.addInvoiceOK.Press();
                    var soLineExt = PXCache<SOLine>.GetExtension<SOLineExt>(soGraph.Transactions.Current);
                    if (lotClass.LotSerTrack != INLotSerTrack.LotNumbered)
                    {
                        soGraph.Transactions.Cache.SetValueExt<SOLine.orderQty>(soGraph.Transactions.Current, total);
                    }
                    soGraph.Transactions.Cache.SetValue<SOLineExt.usrBackloadNbr>(soGraph.Transactions.Current, line.BackloadNbr);
                    soGraph.Transactions.Cache.SetValue<SOLineExt.usrBackloadLineNbr>(soGraph.Transactions.Current, line.BackloadLineNbr);
                    soGraph.Transactions.Update(soGraph.Transactions.Current);
                    if (lotClass.LotSerTrack == INLotSerTrack.LotNumbered)
                    {
                        foreach(string lot in lotNbr)
                        {
                            decimal? totalQtyLot = PXSelect<BackloadSplit, Where<BackloadSplit.backloadNbr, Equal<Required<BackloadSplit.backloadNbr>>,
                            And<BackloadSplit.shipmentLineNbr, Equal<Required<BackloadSplit.shipmentLineNbr>>,
                            And<BackloadSplit.lotSerialNbr, Equal<Required<BackloadSplit.lotSerialNbr>>>>>>.Select(graph, line.BackloadNbr, line.ShipmentLineNbr, lot).RowCast<BackloadSplit>().Sum(f => f.Qty);
                            foreach (SOLineSplit soLineSplit in soGraph.splits.Select())
                            {
                                if(soLineSplit.LotSerialNbr == lot)
                                {
                                    soLineSplit.Qty = totalQtyLot;
                                }
                                soGraph.splits.Update(soLineSplit);
                            }
                            
                        }
                    }
                    if(lotClass.LotSerTrack == INLotSerTrack.NotNumbered)
                    {
                        foreach(SOLineSplit sOLineSplit in soGraph.splits.Select())
                        {
                            sOLineSplit.Qty = total;
                            soGraph.splits.Update(sOLineSplit);
                        }
                    }
                }
            }
            
            foreach (SOLineSplit splt in soGraph.splits.Select())
            {
                if (splt.Qty == 0m)
                {
                    soGraph.splits.Delete(splt);
                }
            }
            soGraph.Actions.PressSave();
            
            #region CreateShipment

            var shipment = (SOShipment)shipGraph.Document.Cache.CreateInstance();
            shipment.CustomerID = soGraph.Document.Current.CustomerID;
            shipment.Operation = SOShipmentType.Receipt;
            shipment.SiteID = soGraph.Document.Current.DefaultSiteID;
            shipment.Hold = false;
            shipGraph.Document.Update(shipment);

            AddSOFilter addSOFilter = shipGraph.addsofilter.Select();
            addSOFilter.OrderType = soGraph.Document.Current.OrderType;
            addSOFilter.OrderNbr = soGraph.Document.Current.OrderNbr;
            shipGraph.addsofilter.Update(addSOFilter);
            foreach (SOShipmentPlan item in shipGraph.soshipmentplan.Select())//shipmentEntry.soshipmentplan.Select())
            {
                bool include = false;

                foreach (SOLine line in soGraph.Transactions.Select())
                {
                    SOShipmentPlan plan = PXSelectJoin<
                        SOShipmentPlan,
                        InnerJoin<SOLineSplit,
                            On<SOShipmentPlan.planID, Equal<SOLineSplit.planID>>>,
                        Where<SOLineSplit.orderType, Equal<Required<SOLineSplit.orderType>>,
                            And<SOLineSplit.orderNbr, Equal<Required<SOLineSplit.orderNbr>>,
                            And<SOLineSplit.lineNbr, Equal<Required<SOLineSplit.lineNbr>>,
                            And<SOShipmentPlan.planID, Equal<Required<SOShipmentPlan.planID>>>>>>>
                        .Select(shipGraph, line.OrderType, line.OrderNbr, line.LineNbr, item.PlanID);

                    if (plan != null)
                    {
                        include = true;
                        break;
                    }
                }
                item.Selected = include;
                item.PlanDate = shipGraph.Document.Current.ShipDate;
                shipGraph.soshipmentplan.Cache.Update(item);
            }
            shipGraph.addSO.Press();
            shipGraph.Persist();
            
            ConfirmShipment(shipGraph.Document.Current.ShipmentNbr);
            PrepareInvoice(shipGraph.Document.Current.ShipmentNbr);
            PXLongOperation.WaitCompletion(shipGraph.UID);
            #region Release of invoice
            ARTran tran = PXSelectGroupBy<ARTran, Where<ARTran.sOShipmentNbr,Equal<Required<ARTran.sOShipmentNbr>>,
                And<ARTran.sOShipmentType,Equal<Required<ARTran.sOShipmentType>>>>,Aggregate<GroupBy<ARTran.refNbr>>>.Select(shipGraph,shipGraph.Document.Current.ShipmentNbr,shipGraph.Document.Current.ShipmentType);
            ReleaseInvoice(tran.RefNbr,graph);
            INTran reg = PXSelectGroupBy<INTran, Where<INTran.aRDocType, Equal<Required<INTran.aRDocType>>, And<INTran.aRRefNbr, Equal<Required<INTran.aRRefNbr>>>>, Aggregate<GroupBy<INTran.refNbr>>>.Select(shipGraph, ARDocType.CreditMemo, tran.RefNbr);
            ReleaseIssue(reg.RefNbr);
            #endregion
            #region CreateTransfer



            #endregion

            #endregion

        }
        public static void CreateTransferIssue(BackloadEntry graph, List<BackloadLine> lst)
        {
            var transferGraph = PXGraph.CreateInstance<INTransferEntry>();
            var issueGraph = PXGraph.CreateInstance<INIssueEntry>();

            var issueHead = issueGraph.issue.Insert(new INRegister()
            {
                Hold = true,
                TranDesc = "Backload Ref Nbr: " + graph.BackloadHead.Current.BackloadNbr
            });
            //Setting if Auto Charge to Employee
            if (graph.Setup.Current.ChargeToEmployee == true)
            {
                issueGraph.issue.Cache.SetValue<INRegisterExt.usrChargeToEmp>(issueHead, true);
            }
            //--end
            var transferHead = transferGraph.transfer.Insert(new INRegister()
            {
                SiteID = graph.BackloadLine.Current.SiteID,
                ToSiteID = graph.BackloadLine.Current.SiteID,
                TransferType = INTransferType.OneStep,
                TranDesc = "Backload Ref Nbr: " + graph.BackloadHead.Current.BackloadNbr
            });
            foreach (BackloadLine line in lst)
            {
                BackloadType blType = PXSelect<
                    BackloadType,
                    Where<BackloadType.backloadTypeCD, Equal<Required<BackloadType.backloadTypeCD>>>>
                    .Select(graph, line.BackloadType);
                INItemSite warehouseLoc = PXSelect<
                    INItemSite,
                    Where<INItemSite.inventoryID, Equal<Required<INItemSite.inventoryID>>,
                        And<INItemSite.siteID, Equal<Required<INItemSite.siteID>>>>>
                    .Select(graph, line.InventoryID, line.SiteID);
                INLocation myLoc = PXSelect<
                    INLocation,
                    Where<INLocationExt.usrDefaultPickingLocation, Equal<boolTrue>,
                        And<Where<INLocation.siteID, Equal<Required<INLocation.siteID>>>>>>
                    .Select(graph, line.SiteID);
                if (myLoc == null) { throw new PXException("Please check the settings of Warehouse Locations"); }
                INSite siteReturn = PXSelect<INSite, Where<INSite.siteID, Equal<Required<INSite.siteID>>>>.Select(graph, line.SiteID);
                SOShipLine shipmentSelect = PXSelect<
                    SOShipLine,
                    Where<SOShipLine.shipmentNbr, Equal<Required<SOShipLine.shipmentNbr>>,
                        And<SOShipLine.shipmentType, Equal<Required<SOShipLine.shipmentType>>,
                        And<SOShipLine.lineNbr, Equal<Required<SOShipLine.lineNbr>>>>>>.Select(graph, line.ShipmentNbr, line.ShipmentType, line.ShipmentLineNbr);
                foreach (INTransferEntry.INSiteStatusSelected item in transferGraph.sitestatus.Select().RowCast<INTransferEntry.INSiteStatusSelected>().Where(d => d.InventoryID == line.InventoryID && d.LocationID == line.LocationID))
                {
                    item.Selected = true;
                    item.QtySelected = line.Qty;
                    transferGraph.sitestatus.Update(item);   
                }
                transferGraph.addInvSelBySite.PressButton();
                transferGraph.transactions.Cache.SetValue<INTranExt.usrBackloadNbr>(transferGraph.transactions.Current, line.BackloadNbr);
                transferGraph.transactions.Cache.SetValue<INTranExt.usrBackloadType>(transferGraph.transactions.Current, line.BackloadType);
                transferGraph.transactions.Cache.SetValue<INTranExt.usrBackloadID>(transferGraph.transactions.Current, line.BackloadLineNbr);
                transferGraph.transactions.Cache.SetValueExt<INTran.uOM>(transferGraph.transactions.Current, line.UOM);
                if(blType.OneStepStaging == true)
                {
                    transferGraph.transactions.Cache.SetValue<INTran.toLocationID>(transferGraph.transactions.Current,myLoc.LocationID);
                }
                if(blType.OneStepDefaultWarehouseLocation == true)
                {
                    transferGraph.transactions.Cache.SetValue<INTran.toLocationID>(transferGraph.transactions.Current, siteReturn.ReceiptLocationID);
                }
                if(blType.ReturnToDmgWarehouse == true)
                {
                    transferGraph.transactions.Cache.SetValue<INTran.toLocationID>(transferGraph.transactions.Current, siteReturn.ReturnLocationID);
                }
                transferGraph.transactions.Update(transferGraph.transactions.Current);
                if (blType.Issue == true)
                {
                    var insertIssueLine = issueGraph.transactions.Insert(new INTran()
                    {
                        InventoryID = line.InventoryID,
                        SiteID = line.SiteID,
                        Qty = line.Qty,
                        UOM = line.UOM
                        //LocationID = shipmentSelect.LocationID
                    });
                    if (blType.OneStepStaging == true)
                    {
                        issueGraph.transactions.Cache.SetValueExt<INTran.locationID>(insertIssueLine, myLoc.LocationID);
                    }
                    else if (blType.OneStepDefaultWarehouseLocation == true)
                    {
                        issueGraph.transactions.Cache.SetValueExt<INTran.locationID>(insertIssueLine, siteReturn.ReceiptLocationID);
                    }
                    else if (blType.ReturnToDmgWarehouse == true)
                    {
                        issueGraph.transactions.Cache.SetValueExt<INTran.locationID>(insertIssueLine, siteReturn.ReturnLocationID);
                    }
                    else
                    {
                        issueGraph.transactions.Cache.SetValueExt<INTran.locationID>(insertIssueLine, shipmentSelect.LocationID);
                    }
                    issueGraph.transactions.Cache.SetValue<INTranExt.usrBackloadNbr>(insertIssueLine, line.BackloadNbr);
                    issueGraph.transactions.Cache.SetValue<INTranExt.usrBackloadType>(insertIssueLine, line.BackloadType);
                    issueGraph.transactions.Cache.SetValue<INTranExt.usrBackloadID>(insertIssueLine, line.BackloadLineNbr);
                    issueGraph.transactions.Update(insertIssueLine);
                }

            }
            #region 1StepTransfer
            //delete
            foreach (INTran loc in transferGraph.transactions.Select())
            {
                
                var locExt = PXCache<INTran>.GetExtension<INTranExt>(loc);
                graph.BackloadLine.Current.BackloadLineNbr = locExt.UsrBackloadID;
                foreach (BackloadSplit lotSplits in graph.backloadSplits.Select().RowCast<BackloadSplit>().Where(d => d.BackloadNbr == locExt.UsrBackloadNbr && d.BackloadLineNbr == locExt.UsrBackloadID))
                {
                    if (lotSplits != null)
                    {
                        transferGraph.transactions.Current = loc;
                        foreach (INTranSplit item in transferGraph.splits.Select())
                        {
                            transferGraph.splits.Current = item;
                            if (item != null)
                            {
                                transferGraph.splits.Delete(item);
                            }
                        }
                    }
                }
                if (loc.ToLocationID == null)
                {
                    transferGraph.transactions.Delete(loc);
                }
            }
            //--end

            //insert
            foreach (INTran loc in transferGraph.transactions.Select())
            {
                var locExt = PXCache<INTran>.GetExtension<INTranExt>(loc);
                graph.BackloadLine.Current.BackloadLineNbr = locExt.UsrBackloadID;
                foreach (BackloadSplit lotSplits in graph.backloadSplits.Select().RowCast<BackloadSplit>().Where(d => d.BackloadNbr == locExt.UsrBackloadNbr && d.BackloadLineNbr == locExt.UsrBackloadID))
                {
                    transferGraph.transactions.Current = loc;
                    if (lotSplits != null)
                    {
                        var insert = transferGraph.splits.Insert(new INTranSplit()
                        {
                            LocationID = loc.LocationID,
                            LotSerialNbr = lotSplits.NonCmLotSerialNbr,
                            Qty = lotSplits.Qty,
                            UOM = lotSplits.UOM,
                            ExpireDate = loc.ExpireDate
                        });
                        transferGraph.splits.Update(insert);
                    }
                }
            }
            if (transferGraph.transactions.Select().Count > 0)
            {

                transferGraph.Actions.PressSave();
                transferGraph.transfer.Cache.SetValueExt<INRegister.hold>(transferGraph.transfer.Current, false);
                transferGraph.release.Press();
            }
            #endregion
            #region Issueance inserting allocations

            //--Deleting
            foreach (INTran loc in issueGraph.transactions.Select())
            {
                var locExt = PXCache<INTran>.GetExtension<INTranExt>(loc);
                graph.BackloadLine.Current.BackloadLineNbr = locExt.UsrBackloadID;
                foreach (BackloadSplit lotSplits in graph.backloadSplits.Select().RowCast<BackloadSplit>().Where(d => d.BackloadNbr == locExt.UsrBackloadNbr && d.BackloadLineNbr == locExt.UsrBackloadID))
                {
                    if (lotSplits != null)
                    {
                        issueGraph.transactions.Current = loc;
                        foreach (INTranSplit item in issueGraph.splits.Select())
                        {
                            issueGraph.splits.Current = item;
                            if (item != null)
                            {
                                issueGraph.splits.Delete(item);
                            }
                        }
                    }
                }
            }
            //--end

            //insert
            foreach (INTran loc in issueGraph.transactions.Select())
            {
                var locExt = PXCache<INTran>.GetExtension<INTranExt>(loc);
                graph.BackloadLine.Current.BackloadLineNbr = locExt.UsrBackloadID;
                foreach (BackloadSplit lotSplits in graph.backloadSplits.Select().RowCast<BackloadSplit>().Where(d => d.BackloadNbr == locExt.UsrBackloadNbr && d.BackloadLineNbr == locExt.UsrBackloadID))
                {
                    issueGraph.transactions.Current = loc;
                    if (lotSplits != null)
                    {
                        var insert = issueGraph.splits.Insert(new INTranSplit()
                        {
                            LocationID = loc.LocationID,
                            LotSerialNbr = lotSplits.NonCmLotSerialNbr,
                            Qty = lotSplits.Qty,
                            UOM = lotSplits.UOM,
                            ExpireDate = loc.ExpireDate
                        });
                        issueGraph.splits.Update(insert);
                    }
                }
            }
            //throw new PXRedirectRequiredException(issueGraph, null);
            #endregion
            
            if(issueGraph.transactions.Select().Count > 0)
            {
                #region Charge to Employee
                if (graph.Setup.Current.ChargeToEmployee == true)
                {
                    var issueGraphExt = issueGraph.GetExtension<DispatchINIssueEntry_Extension>();
                    LPLoadPlanLine tripTicket = PXSelect<LPLoadPlanLine, Where<LPLoadPlanLine.shipmentNbr, Equal<Required<LPLoadPlanLine.shipmentNbr>>>>.Select(graph, graph.BackloadLine.Current.ShipmentNbr);

                    if (tripTicket != null)
                    {
                        LPLoadPlanMaster driver = PXSelect<LPLoadPlanMaster, Where<LPLoadPlanMaster.tripTIcketNbr, Equal<Required<LPLoadPlanMaster.tripTIcketNbr>>>>.Select(graph, tripTicket.TripTicketNbr);
                        EPEmployee emp = PXSelect<EPEmployee, Where<EPEmployee.acctName, Equal<Required<EPEmployee.acctName>>>>.Select(graph, driver.DriverName);
                        int crew = PXSelect<CrewLine, Where<CrewLine.tripTicketNbr, Equal<Required<CrewLine.tripTicketNbr>>>>.Select(graph, tripTicket.TripTicketNbr).Count();
                        crew = crew + 1;
                        decimal? chargeAmt = issueGraph.issue.Current.TotalAmount / (crew);
                        foreach (CrewLine cLine in PXSelect<CrewLine, Where<CrewLine.tripTicketNbr, Equal<Required<CrewLine.tripTicketNbr>>>>.Select(graph, tripTicket.TripTicketNbr))
                        {
                            var insertEmpCharge = issueGraphExt.EmpCharges.Insert(new INEmployeeCharges()
                            {
                                EmployeeID = cLine.Crewid,
                                ChargeAmount = chargeAmt
                            });
                            issueGraphExt.EmpCharges.Update(insertEmpCharge);
                        }
                        if (driver != null)
                        {
                            var insertDriver = issueGraphExt.EmpCharges.Insert(new INEmployeeCharges()
                            {
                                EmployeeID = emp.BAccountID,
                                ChargeAmount = chargeAmt
                            });
                            issueGraphExt.EmpCharges.Update(insertDriver);
                        }
                    }
                }
                issueGraph.Actions.PressSave();
                #endregion
                foreach (BackloadLine line in lst)
                    {
                        BackloadType blType = PXSelect<
                           BackloadType,
                           Where<BackloadType.backloadTypeCD, Equal<Required<BackloadType.backloadTypeCD>>>>
                       .Select(graph, line.BackloadType);
                        if (blType != null)
                        {
                            if (blType.Issue == true)
                            {
                                graph.BackloadLine.Cache.SetValue<BackloadLine.issueRefNbr>(line, issueGraph.issue.Current.RefNbr);
                                graph.BackloadLine.Update(line);
                            }
                        }
                    }
                graph.Persist();
            }
            //--end

        }
        public static void ConfirmShipment(string shipNbr)
        {
            var shipmentEntry = PXGraph.CreateInstance<SOShipmentEntry>();
            shipmentEntry.Document.Current = shipmentEntry.Document.Search<SOShipment.shipmentNbr>(shipNbr);
            shipmentEntry.Document.Update(shipmentEntry.Document.Current);
            
            foreach (var action in (shipmentEntry.action.GetState(null) as PXButtonState).Menus)
            {
                if (action.Command == "Confirm Shipment")
                {
                    PXAdapter adapter2 = new PXAdapter(new DummyView(shipmentEntry, shipmentEntry.Document.View.BqlSelect, new List<object> { shipmentEntry.Document.Current }));
                    adapter2.Menu = action.Command;
                    shipmentEntry.action.PressButton(adapter2);
                }
            }
        }
        public static void PrepareInvoice(string shipNbr)
        {
            var shipmentEntry = PXGraph.CreateInstance<SOShipmentEntry>();
            shipmentEntry.Document.Current = shipmentEntry.Document.Search<SOShipment.shipmentNbr>(shipNbr);
            shipmentEntry.Document.Update(shipmentEntry.Document.Current);

            foreach (var action in (shipmentEntry.action.GetState(null) as PXButtonState).Menus)
            {
                if (action.Command == "Prepare Invoice")
                {
                    PXAdapter adapter2 = new PXAdapter(new DummyView(shipmentEntry, shipmentEntry.Document.View.BqlSelect, new List<object> { shipmentEntry.Document.Current }));
                    adapter2.Menu = action.Command;
                    shipmentEntry.action.PressButton(adapter2);
                }
            }
        }
        public static void ReleaseInvoice(string invoiceNbr, BackloadEntry graph)
        {
            var invoiceGraph = PXGraph.CreateInstance<SOInvoiceEntry>();
            invoiceGraph.Document.Current = invoiceGraph.Document.Search<ARInvoice.refNbr>(invoiceNbr, ARDocType.CreditMemo);

            var invoiceCurrent = invoiceGraph.Document.Current;
            //invoiceGraph.Document.Cache.SetValueExt<ARRegisterExtOTC.usrGRRef>(invoiceCurrent, 0123);
            if (invoiceGraph.ARSetup.Current.RequireControlTotal == true)
            {
                invoiceCurrent.CuryOrigDocAmt = invoiceCurrent.CuryDocBal;
            }
            invoiceGraph.Persist();
            invoiceGraph.Document.View.RequestRefresh();
            invoiceGraph.Document.Cache.ClearQueryCache();
            invoiceGraph.release.Press();
            PXLongOperation.WaitCompletion(invoiceGraph.UID);
            foreach(BackloadLine line in graph.BackloadLine.Select())
            {
                graph.BackloadLine.Cache.SetValue<BackloadLine.creditMemoRefNo>(line, invoiceGraph.Document.Current.RefNbr);
                graph.BackloadLine.Update(line);
            }
            graph.Persist();
        }
        public static void ReleaseIssue(string refNbr)
        {
            var issueGraph = PXGraph.CreateInstance<INIssueEntry>();

            issueGraph.issue.Current = issueGraph.issue.Search<INRegister.refNbr>(refNbr);
            issueGraph.release.Press();
            PXLongOperation.WaitCompletion(issueGraph.UID);
        }
        public static void TransferGoodsDamage(List<BackloadLine> lst,BackloadEntry graph)
        {
            var transferGraph = PXGraph.CreateInstance<INTransferEntry>();
            var transferHead = transferGraph.transfer.Insert(new INRegister()
            {
                SiteID = graph.BackloadLine.Current.SiteID,
                ToSiteID = graph.BackloadLine.Current.SiteID,
                TransferType = INTransferType.OneStep
            });
            foreach (BackloadLine line in lst)
            {
                BackloadType blType = PXSelect<
                    BackloadType,
                    Where<BackloadType.backloadTypeCD, Equal<Required<BackloadType.backloadTypeCD>>>>
                    .Select(graph, line.BackloadType);
                INLocation goods = PXSelect<
                    INLocation,
                    Where<INLocationExt.usrGoods, Equal<boolTrue>,
                        And<Where<INLocation.siteID, Equal<Required<INLocation.siteID>>>>>>
                    .Select(graph, line.SiteID);
                INLocation damaged = PXSelect<
                    INLocation,
                    Where<INLocationExt.usrDamaged, Equal<boolTrue>,
                        And<Where<INLocation.siteID, Equal<Required<INLocation.siteID>>>>>>
                    .Select(graph, line.SiteID);
                INSite siteReturn = PXSelect<INSite, Where<INSite.siteID, Equal<Required<INSite.siteID>>>>.Select(graph, line.SiteID);
                INLotSerClass lot = PXSelectJoin<INLotSerClass,
                      LeftJoin<InventoryItem, On<InventoryItem.lotSerClassID, Equal<INLotSerClass.lotSerClassID>>>,
                      Where<InventoryItem.inventoryID, Equal<Required<InventoryItem.inventoryID>>>>.Select(graph, line.InventoryID);
                foreach (INTransferEntry.INSiteStatusSelected item in transferGraph.sitestatus.Select().RowCast<INTransferEntry.INSiteStatusSelected>().Where(d => d.InventoryID == line.InventoryID && d.LocationID == siteReturn.ReturnLocationID))
                {
                    
                    item.Selected = true;
                    item.QtySelected = line.Qty;
                    transferGraph.sitestatus.Update(item);
                }
                transferGraph.addInvSelBySite.PressButton();
                if(lot.LotSerTrack == INLotSerTrack.LotNumbered)
                {
                    transferGraph.transactions.Cache.SetValue<INTran.qty>(transferGraph.transactions.Current, 0m);
                }
                transferGraph.transactions.Cache.SetValue<INTranExt.usrBackloadNbr>(transferGraph.transactions.Current, line.BackloadNbr);
                transferGraph.transactions.Cache.SetValue<INTranExt.usrBackloadType>(transferGraph.transactions.Current, line.BackloadType);
                transferGraph.transactions.Cache.SetValue<INTranExt.usrBackloadID>(transferGraph.transactions.Current, line.BackloadLineNbr);
                transferGraph.transactions.Cache.SetValueExt<INTran.uOM>(transferGraph.transactions.Current, line.UOM);
                if(blType.Goods == true)
                {
                    transferGraph.transactions.Cache.SetValue<INTran.toLocationID>(transferGraph.transactions.Current,goods.LocationID);
                }
                if (blType.Damage == true)
                {
                    transferGraph.transactions.Cache.SetValue<INTran.toLocationID>(transferGraph.transactions.Current, damaged.LocationID);
                }
                transferGraph.transactions.Update(transferGraph.transactions.Current);
            }
            //transferGraph.Persist();

            //--Delete
            foreach (INTran loc in transferGraph.transactions.Select())
            {
                var locExt = PXCache<INTran>.GetExtension<INTranExt>(loc);
                graph.BackloadLine.Current.BackloadLineNbr = locExt.UsrBackloadID;
                foreach (BackloadSplit lotSplits in graph.backloadSplits.Select().RowCast<BackloadSplit>().Where(d => d.BackloadNbr == locExt.UsrBackloadNbr && d.BackloadLineNbr == locExt.UsrBackloadID))
                {
                    transferGraph.transactions.Current = loc;
                    if (lotSplits != null)
                    {
                        foreach (INTranSplit item in transferGraph.splits.Select())
                        {
                            transferGraph.splits.Current = item;
                            if (item != null)
                            {
                                transferGraph.splits.Delete(item);
                            }
                        }
                    }
                }
            }
            //--endofDelete
            //InsertingAllocations
            foreach (INTran loc in transferGraph.transactions.Select())
            {
                List<string> lotNbr = new List<string>();
                var locExt = PXCache<INTran>.GetExtension<INTranExt>(loc);
                graph.BackloadLine.Current.BackloadLineNbr = locExt.UsrBackloadID;
                
                foreach (BackloadSplit lotSplits in graph.backloadSplits.Select().RowCast<BackloadSplit>().Where(d => d.BackloadNbr == locExt.UsrBackloadNbr && d.BackloadLineNbr == locExt.UsrBackloadID))
                {
                    transferGraph.transactions.Current = loc;
                    if (lotSplits != null)
                    {
                        if (!lotNbr.Contains(lotSplits.LotSerialNbr))
                        {
                            lotNbr.Add(lotSplits.LotSerialNbr);
                            var insert = transferGraph.splits.Insert(new INTranSplit()
                            {
                                LocationID = loc.LocationID,
                                LotSerialNbr = lotSplits.LotSerialNbr,
                                Qty = lotSplits.Qty,
                                UOM = lotSplits.UOM,
                                ExpireDate = loc.ExpireDate
                            });
                            transferGraph.splits.Update(insert);
                        }
                    }
                }
            }
            //--EndofInserting
            if (transferGraph.transactions.Select().Count > 0)
            {
                
                transferGraph.Actions.PressSave();
                transferGraph.transfer.Cache.SetValueExt<INRegister.hold>(transferGraph.transfer.Current,false);
                transferGraph.release.Press();
            }
        }
        public static void AutoCreateRTV(List<BackloadLine> lst, BackloadEntry graph)
        {
            var receiptGraph = PXGraph.CreateInstance<POReceiptEntry>();
            List<BackloadLine> vendors = new List<BackloadLine>();
            foreach(BackloadLine lines in lst)
            {
                BackloadType blType = PXSelect<
                    BackloadType,
                    Where<BackloadType.backloadTypeCD, Equal<Required<BackloadType.backloadTypeCD>>>>
                    .Select(graph, lines.BackloadType);
                if(blType.Damage == true)
                {
                    if (!vendors.Contains(lines))
                    {
                        vendors.Add(lines);
                    }
                }
            }
            var grp = vendors.GroupBy(d => d.VendorID);
            foreach (var grpItem in grp)
            {
                int? vendorID = grpItem.Key;
                PXTrace.WriteInformation(grpItem.Key.ToString());
                var insertVendor = receiptGraph.Document.Insert(new POReceipt()
                {
                    ReceiptType = POReceiptType.POReturn
                });
                receiptGraph.Document.Cache.SetValueExt<POReceipt.vendorID>(insertVendor, vendorID);
                receiptGraph.Document.Update(insertVendor);
                foreach(BackloadLine line in grpItem)
                {
                    INSite locDmg = PXSelect<INSite, Where<INSite.siteID, Equal<Required<INSite.siteID>>>>.Select(graph, line.SiteID);
                    var insertLine = receiptGraph.transactions.Insert(new POReceiptLine()
                    {
                        InventoryID = line.InventoryID,
                        SiteID = line.SiteID,
                        ReceiptQty = line.Qty,
                        UOM = line.UOM
                    });
                    receiptGraph.transactions.Cache.SetValue<POReceiptLine.locationID>(insertLine, locDmg.ReturnLocationID);
                    receiptGraph.transactions.Cache.SetValue<POReceiptLineExt.usrBackloadNbr>(insertLine,line.BackloadNbr);
                    receiptGraph.transactions.Cache.SetValue<POReceiptLineExt.usrBackloadLineNbr>(insertLine, line.BackloadLineNbr);
                    receiptGraph.transactions.Update(insertLine);
                    receiptGraph.Persist();
                    graph.BackloadLine.Cache.SetValue<BackloadLine.rtvRefNbr>(line, receiptGraph.Document.Current.ReceiptNbr);
                    graph.BackloadLine.Update(line);
                }
                graph.Persist();
                //--Delete Allocations
                foreach (POReceiptLine poLine in receiptGraph.transactions.Select())
                {
                    INLotSerClass lot = PXSelectJoin<INLotSerClass,
                    LeftJoin<InventoryItem, On<InventoryItem.lotSerClassID, Equal<INLotSerClass.lotSerClassID>>>,
                    Where<InventoryItem.inventoryID, Equal<Required<InventoryItem.inventoryID>>>>.Select(graph, poLine.InventoryID);
                    receiptGraph.transactions.Current = poLine;
                    if(lot.LotSerTrack == INLotSerTrack.LotNumbered)
                    {
                        foreach(POReceiptLineSplit line in receiptGraph.splits.Select())
                        {
                            receiptGraph.splits.Delete(line);
                        }
                    }
                }
                //-- End Delete Allocations
                // -- Inserting Allocations
                foreach(POReceiptLine insertLotLine in receiptGraph.transactions.Select())
                {
                    INLotSerClass lot = PXSelectJoin<INLotSerClass,
                   LeftJoin<InventoryItem, On<InventoryItem.lotSerClassID, Equal<INLotSerClass.lotSerClassID>>>,
                   Where<InventoryItem.inventoryID, Equal<Required<InventoryItem.inventoryID>>>>.Select(graph, insertLotLine.InventoryID);
                    
                    receiptGraph.transactions.Current = insertLotLine;
                    var insertExt = PXCache<POReceiptLine>.GetExtension<POReceiptLineExt>(insertLotLine);
                    if(lot.LotSerTrack != INLotSerTrack.NotNumbered)
                    {
                        PXTrace.WriteInformation(insertExt.UsrBackloadNbr.ToString() + "  Line: " + insertExt.UsrBackloadLineNbr.ToString());
                        graph.BackloadLine.Current.BackloadLineNbr = insertExt.UsrBackloadLineNbr;
                        
                        foreach (BackloadSplit bSplits in graph.backloadSplits.Select().RowCast<BackloadSplit>().Where(d => d.BackloadNbr == insertExt.UsrBackloadNbr && d.BackloadLineNbr == insertExt.UsrBackloadLineNbr))
                        {
                            if (bSplits != null)
                            {
                                PXTrace.WriteInformation(bSplits.BackloadLineNbr.ToString() + " Line " + bSplits.NonCmLotSerialNbr);
                                POReceiptLineSplit splts = (POReceiptLineSplit)receiptGraph.splits.Cache.CreateInstance();
                                splts.LocationID = insertLotLine.LocationID;
                                splts.LotSerialNbr = bSplits.NonCmLotSerialNbr != null ? bSplits.NonCmLotSerialNbr : bSplits.LotSerialNbr;
                                splts.Qty = bSplits.Qty;
                                splts.UOM = bSplits.UOM;
                                splts.ExpireDate = lot.LotSerIssueMethod == INLotSerIssueMethod.Expiration ? insertLotLine.ExpireDate : null;
                                receiptGraph.splits.Insert(splts);
                            }
                        }
                    }
                }
                // -- End inserting Allocations
                if (receiptGraph.transactions.Select().Count > 0)
                {
                    receiptGraph.Persist();
                }
            }

        }
        internal class DummyView : PXView
        {
            List<object> _Records;
            internal DummyView(PXGraph graph, BqlCommand command, List<object> records)
                : base(graph, true, command)
            {
                _Records = records;
            }
            public override List<object> Select(object[] currents, object[] parameters, object[] searches, string[] sortcolumns, bool[] descendings, PXFilterRow[] filters, ref int startRow, int maximumRows, ref int totalRows)
            {
                return _Records;
            }
        }

        
        #endregion

    }
    #region CustomSelector

    public class BLoadTypeSelectorAttribute : PXCustomSelectorAttribute
    {
        public BLoadTypeSelectorAttribute() : base(typeof(Search<BackloadType.backloadTypeCD>), typeof(BackloadType.backloadTypeCD), typeof(BackloadType.descr))
        {
            DescriptionField = typeof(BackloadType.descr);
        }
        
        protected virtual IEnumerable GetRecords()
        {
            PXCache cache = this._Graph.Caches[typeof(Backload)];
            var current = (Backload)cache.Current;

            if (current.IsCM == true)
            {
                PXSelectBase<BackloadType> queryCM = new PXSelect<BackloadType, Where<BackloadType.isActive, Equal<True>, And<BackloadTypeExt.usrIsTransfer, Equal<False>, And<BackloadType.backloadReturn, Equal<True>>>>>(this._Graph);
                return queryCM.Select();
            }
            else
            {
                PXSelectBase<BackloadType> queryNonCM = new PXSelect<BackloadType, Where<BackloadType.isActive, Equal<True>, And<BackloadTypeExt.usrIsTransfer, Equal<False>, And<BackloadType.backloadReturn, Equal<False>>>>>(this._Graph);
                return queryNonCM.Select();
            }
        }
    }

    #endregion
}]]></CDATA>
</Graph>